'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Const = require('./Const');

var _Const2 = _interopRequireDefault(_Const);

var _TableRow = require('./TableRow');

var _TableRow2 = _interopRequireDefault(_TableRow);

var _TableColumn = require('./TableColumn');

var _TableColumn2 = _interopRequireDefault(_TableColumn);

var _TableEditColumn = require('./TableEditColumn');

var _TableEditColumn2 = _interopRequireDefault(_TableEditColumn);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var isFun = function isFun(obj) {
  return obj && typeof obj === 'function';
};

var mapColumns = function mapColumns(column, i, data, r, object) {
  var fieldValue = data[column.name];
  if (column.name !== object.props.keyField && // Key field can't be edit
  column.editable && // column is editable? default is true, user can set it false
  object.state.currEditCell !== null && object.state.currEditCell.rid === r && object.state.currEditCell.cid === i) {
    var editable = column.editable;
    var format = column.format ? function (value) {
      return column.format(value, data, column.formatExtraData, r).replace(/<.*?>/g, '');
    } : false;
    if (isFun(column.editable)) {
      editable = column.editable(fieldValue, data, r, i);
    }

    return _react2.default.createElement(_TableEditColumn2.default, {
      completeEdit: object.handleCompleteEditCell
      // add by bluespring for column editor customize
      , editable: editable,
      customEditor: column.customEditor,
      format: column.format ? format : false,
      key: i,
      blurToSave: object.props.cellEdit.blurToSave,
      rowIndex: r,
      colIndex: i,
      row: data,
      fieldValue: fieldValue });
  } else {
    // add by bluespring for className customize
    var columnChild = fieldValue && fieldValue.toString();
    var columnTitle = null;
    var colSpan = 1;
    var tdClassName = column.className;
    if (isFun(column.className)) {
      tdClassName = column.className(fieldValue, data, r, i);
    }

    if (typeof column.format !== 'undefined') {
      var formattedValue = column.format(fieldValue, data, column.formatExtraData, r);
      if (!_react2.default.isValidElement(formattedValue)) {
        columnChild = _react2.default.createElement('div', { dangerouslySetInnerHTML: { __html: formattedValue } });
      } else {
        columnChild = formattedValue;
        columnTitle = column.columnTitle && formattedValue ? formattedValue.toString() : null;
      }
    } else {
      columnTitle = column.columnTitle && fieldValue ? fieldValue.toString() : null;
    }
    return _react2.default.createElement(
      _TableColumn2.default,
      { key: i,
        dataAlign: column.align,
        className: tdClassName,
        columnTitle: columnTitle,
        colSpan: colSpan,
        cellEdit: object.props.cellEdit,
        hidden: column.hidden,
        onEdit: object.handleEditCell,
        width: column.width },
      columnChild
    );
  }
};

var mapTableRows = function mapTableRows(data, r, unselectable, isSelectRowDefined, inputType, CustomComponent, object) {
  var tableColumns = object.props.columns.map(function (column, i) {
    return mapColumns(column, i, data, r, object);
  }, object);
  var key = data[object.props.keyField];
  var disable = unselectable.indexOf(key) !== -1;
  var selected = object.props.selectedRowKeys.indexOf(key) !== -1;
  var selectRowColumn = isSelectRowDefined && !object.props.selectRow.hideSelectColumn ? object.renderSelectRowColumn(selected, inputType, disable, CustomComponent, r) : null;
  // add by bluespring for className customize
  var trClassName = object.props.trClassName;
  if (isFun(object.props.trClassName)) {
    trClassName = object.props.trClassName(data, r);
  }
  return _react2.default.createElement(
    _TableRow2.default,
    { isSelected: selected, key: key, className: trClassName, ref: key,
      selectRow: isSelectRowDefined ? object.props.selectRow : undefined,
      enableCellEdit: object.props.cellEdit.mode !== _Const2.default.CELL_EDIT_NONE,
      onRowClick: object.handleRowClick,
      onRowDoubleClick: object.handleRowDoubleClick,
      onRowMouseOver: object.handleRowMouseOver,
      onRowMouseOut: object.handleRowMouseOut,
      onSelectRow: object.handleSelectRow,
      unselectableRow: disable },
    selectRowColumn,
    tableColumns
  );
};

var TableFooter = function (_Component) {
  _inherits(TableFooter, _Component);

  function TableFooter(props) {
    _classCallCheck(this, TableFooter);

    var _this = _possibleConstructorReturn(this, (TableFooter.__proto__ || Object.getPrototypeOf(TableFooter)).call(this, props));

    _this.handleRowMouseOut = function () {
      return _this.__handleRowMouseOut__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.handleRowMouseOver = function () {
      return _this.__handleRowMouseOver__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.handleRowClick = function () {
      return _this.__handleRowClick__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.handleRowDoubleClick = function () {
      return _this.__handleRowDoubleClick__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.handleSelectRow = function () {
      return _this.__handleSelectRow__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.handleSelectRowColumChange = function () {
      return _this.__handleSelectRowColumChange__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.handleEditCell = function () {
      return _this.__handleEditCell__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.handleCompleteEditCell = function () {
      return _this.__handleCompleteEditCell__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.state = {
      currEditCell: null
    };
    return _this;
  }

  _createClass(TableFooter, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var tableClasses = (0, _classnames2.default)('table', {
        'table-striped': this.props.striped,
        'table-bordered': this.props.bordered,
        'table-hover': this.props.hover,
        'table-condensed': this.props.condensed
      }, this.props.tableFooterClass);

      var unselectable = this.props.selectRow.unselectable || [];
      var isSelectRowDefined = this._isSelectRowDefined();
      var tableHeader = this.renderTableHeader(isSelectRowDefined);
      var inputType = this.props.selectRow.mode === _Const2.default.ROW_SELECT_SINGLE ? 'radio' : 'checkbox';
      var CustomComponent = this.props.selectRow.customComponent;

      var tableRows = this.props.data.map(function (data, r) {
        return mapTableRows(data, r, unselectable, isSelectRowDefined, inputType, CustomComponent, _this2);
      });

      if (tableRows.length === 0) {
        tableRows.push(_react2.default.createElement(
          _TableRow2.default,
          { key: '##table-empty##' },
          _react2.default.createElement(
            'td',
            { colSpan: this.props.columns.length + (isSelectRowDefined ? 1 : 0),
              className: 'react-bs-table-no-data' },
            this.props.noDataText || _Const2.default.NO_DATA_TEXT
          )
        ));
      }
      var footerRows = this.props.data ? this.props.data.map(function (data, r) {
        return mapTableRows(data, r, unselectable, isSelectRowDefined, inputType, CustomComponent, _this2);
      }) : [];

      return _react2.default.createElement(
        'div',
        { ref: 'container',
          className: (0, _classnames2.default)('react-bs-container-footer', this.props.bodyContainerClass),
          style: this.props.style },
        _react2.default.createElement(
          'table',
          { className: tableClasses, ref: 'table' },
          tableHeader,
          _react2.default.createElement(
            'tfoot',
            { ref: 'tfoot' },
            footerRows
          )
        )
      );
    }
  }, {
    key: 'renderTableHeader',
    value: function renderTableHeader(isSelectRowDefined) {
      var selectRowHeader = null;

      if (isSelectRowDefined) {
        var style = {
          width: 30,
          minWidth: 30
        };
        if (!this.props.selectRow.hideSelectColumn) {
          selectRowHeader = _react2.default.createElement('col', { style: style, key: -1 });
        }
      }
      var isResizable = this.props.resizable;
      var theader = this.props.columns.map(function (column, i) {
        var style = {
          display: column.hidden ? 'none' : null
        };
        if (!isResizable && column.width) {
          var width = parseInt(column.width, 10);
          style.width = width;
          /** add min-wdth to fix user assign column width
          not eq offsetWidth in large column table **/
          style.minWidth = width;
        }
        column.className = column.resize ? column.className + ' resizable' : column.className;
        return _react2.default.createElement('col', { style: style, key: i, className: column.className });
      });

      return _react2.default.createElement(
        'colgroup',
        { ref: 'header' },
        selectRowHeader,
        theader
      );
    }
  }, {
    key: '__handleRowMouseOut__REACT_HOT_LOADER__',
    value: function __handleRowMouseOut__REACT_HOT_LOADER__(rowIndex, event) {
      var targetRow = this.props.data[rowIndex];
      this.props.onRowMouseOut(targetRow, event);
    }
  }, {
    key: '__handleRowMouseOver__REACT_HOT_LOADER__',
    value: function __handleRowMouseOver__REACT_HOT_LOADER__(rowIndex, event) {
      var targetRow = this.props.data[rowIndex];
      this.props.onRowMouseOver(targetRow, event);
    }
  }, {
    key: '__handleRowClick__REACT_HOT_LOADER__',
    value: function __handleRowClick__REACT_HOT_LOADER__(rowIndex) {
      var selectedRow = void 0;
      var _props = this.props,
          data = _props.data,
          onRowClick = _props.onRowClick;

      data.forEach(function (row, i) {
        if (i === rowIndex - 1) {
          selectedRow = row;
        }
      });
      onRowClick(selectedRow);
    }
  }, {
    key: '__handleRowDoubleClick__REACT_HOT_LOADER__',
    value: function __handleRowDoubleClick__REACT_HOT_LOADER__(rowIndex) {
      var selectedRow = void 0;
      var _props2 = this.props,
          data = _props2.data,
          onRowDoubleClick = _props2.onRowDoubleClick;

      data.forEach(function (row, i) {
        if (i === rowIndex - 1) {
          selectedRow = row;
        }
      });
      onRowDoubleClick(selectedRow);
    }
  }, {
    key: '__handleSelectRow__REACT_HOT_LOADER__',
    value: function __handleSelectRow__REACT_HOT_LOADER__(rowIndex, isSelected, e) {
      var selectedRow = void 0;
      var _props3 = this.props,
          data = _props3.data,
          onSelectRow = _props3.onSelectRow;

      data.forEach(function (row, i) {
        if (i === rowIndex - 1) {
          selectedRow = row;
          return false;
        }
      });
      onSelectRow(selectedRow, isSelected, e);
    }
  }, {
    key: '__handleSelectRowColumChange__REACT_HOT_LOADER__',
    value: function __handleSelectRowColumChange__REACT_HOT_LOADER__(e, rowIndex) {
      if (!this.props.selectRow.clickToSelect || !this.props.selectRow.clickToSelectAndEditCell) {
        this.handleSelectRow(rowIndex + 1, e.currentTarget.checked, e);
      }
    }
  }, {
    key: '__handleEditCell__REACT_HOT_LOADER__',
    value: function __handleEditCell__REACT_HOT_LOADER__(rowIndex, columnIndex, e) {
      if (this._isSelectRowDefined()) {
        columnIndex--;
        if (this.props.selectRow.hideSelectColumn) columnIndex++;
      }
      rowIndex--;
      var stateObj = {
        currEditCell: {
          rid: rowIndex,
          cid: columnIndex
        }
      };

      if (this.props.selectRow.clickToSelectAndEditCell && this.props.cellEdit.mode !== _Const2.default.CELL_EDIT_DBCLICK) {
        var selected = this.props.selectedRowKeys.indexOf(this.props.data[rowIndex][this.props.keyField]) !== -1;
        this.handleSelectRow(rowIndex + 1, !selected, e);
      }
      this.setState(stateObj);
    }
  }, {
    key: '__handleCompleteEditCell__REACT_HOT_LOADER__',
    value: function __handleCompleteEditCell__REACT_HOT_LOADER__(newVal, rowIndex, columnIndex) {
      this.setState({ currEditCell: null });
      if (newVal !== null) {
        this.props.cellEdit.__onCompleteEdit__(newVal, rowIndex, columnIndex);
      }
    }
  }, {
    key: 'renderSelectRowColumn',
    value: function renderSelectRowColumn(selected, inputType, disabled) {
      var _this3 = this;

      var CustomComponent = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
      var rowIndex = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : null;

      return _react2.default.createElement(
        _TableColumn2.default,
        { dataAlign: 'center' },
        CustomComponent ? _react2.default.createElement(CustomComponent, { type: inputType, checked: selected, disabled: disabled,
          rowIndex: rowIndex,
          onChange: function onChange(e) {
            return _this3.handleSelectRowColumChange(e, e.currentTarget.parentElement.parentElement.parentElement.rowIndex);
          } }) : _react2.default.createElement('input', { type: inputType, checked: selected, disabled: disabled,
          onChange: function onChange(e) {
            return _this3.handleSelectRowColumChange(e, e.currentTarget.parentElement.parentElement.rowIndex);
          } })
      );
    }
  }, {
    key: '_isSelectRowDefined',
    value: function _isSelectRowDefined() {
      return this.props.selectRow.mode === _Const2.default.ROW_SELECT_SINGLE || this.props.selectRow.mode === _Const2.default.ROW_SELECT_MULTI;
    }
  }]);

  return TableFooter;
}(_react.Component);

TableFooter.propTypes = {
  data: _react.PropTypes.array,
  columns: _react.PropTypes.array,
  striped: _react.PropTypes.bool,
  bordered: _react.PropTypes.bool,
  hover: _react.PropTypes.bool,
  condensed: _react.PropTypes.bool,
  keyField: _react.PropTypes.string,
  selectedRowKeys: _react.PropTypes.array,
  onRowClick: _react.PropTypes.func,
  onRowDoubleClick: _react.PropTypes.func,
  onSelectRow: _react.PropTypes.func,
  noDataText: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.object]),
  style: _react.PropTypes.object,
  tableFooterClass: _react.PropTypes.string,
  bodyContainerClass: _react.PropTypes.string,
  resizable: _react.PropTypes.bool
};
var _default = TableFooter;
exports.default = _default;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(isFun, 'isFun', '/Users/sameer/www/test/react/react-bootstrap-table/src/TableFooter.js');

  __REACT_HOT_LOADER__.register(mapColumns, 'mapColumns', '/Users/sameer/www/test/react/react-bootstrap-table/src/TableFooter.js');

  __REACT_HOT_LOADER__.register(mapTableRows, 'mapTableRows', '/Users/sameer/www/test/react/react-bootstrap-table/src/TableFooter.js');

  __REACT_HOT_LOADER__.register(TableFooter, 'TableFooter', '/Users/sameer/www/test/react/react-bootstrap-table/src/TableFooter.js');

  __REACT_HOT_LOADER__.register(_default, 'default', '/Users/sameer/www/test/react/react-bootstrap-table/src/TableFooter.js');
}();

;